                 $INCLUDE (Map.inc)                

CMD_Idel         EQU      0x00
CMD_Read         EQU      0x01
CMD_Program      EQU      0x02
CMD_Erase        EQU      0x03
;IAP parameter preset.
				 NAME     EEPROM
				 PUBLIC   IAP_Write
				 
EEPROM_Func      SEGMENT  CODE
                 RSEG     EEPROM_Func
					 
;IAP_Idel:        CLR      A
                 ;MOV      IAP_CONTR,A
				 ;MOV      IAP_CMD,A
				 ;MOV      IAP_TRIG,A
				 ;MOV      IAP_ADDRH,A
                 ;MOV      IAP_ADDRL,A
;Reset following registers.
                 ;RET

IAP_RWE:         ORL      IAP_CONTR,#0x80
;Enable IAP function.
                 MOV      IAP_CMD,R7
;Send IAP command.
                 MOV      IAP_ADDRL,R5
				 MOV      IAP_ADDRH,R4
;Set target address.
                 MOV      A,R7
				 ADD      A,#0xFE
				 JC       IAP_W_E_Op
;Check the type of required IAP operation, read, write
;or erase. 
                 MOV      IAP_TRIG,#0x5A
				 MOV      IAP_TRIG,#0xA5
;Confirm requirement which was submitted before.
                 NOP
;Wait operation complete.
                 MOV      R7,IAP_DATA
;Output result is saved to R7.
;                 ACALL    IAP_Idel
                 RET
IAP_W_E_Op:      MOV      IAP_DATA,R3
;Send data is to write into the EEPROM, but it will be
;ingnored in sector erasion operation.
                 MOV      IAP_TRIG,#0x5A
				 MOV      IAP_TRIG,#0xA5
;Confirm requirement which was submitted before.
                 NOP
;Wait operation complete.
;                 ACALL    IAP_Idel
                 RET
;This function combines three types of EEPROM operations:
;Sector erasing, Byte reading, Byte writing.
IAP_Write:       MOV       A,R7
                 MOV       R3,A
;The value is to write to the EEPROM.
                 MOV      R7,#CMD_Erase 
;Set erase sector command.
;Target address is already saved to [R4,R5].
                 ACALL    IAP_RWE
;Erase the specific sector of EEPROM for next
;write operation.
                 MOV      R7,#CMD_Program 
;Set write command.
                 ACALL    IAP_RWE
;Execute write operation.
                 RET
;Single byte writed to a target address.
				 END