                 $INCLUDE (Map.inc)

				 NAME     Main
				 PUBLIC   Main

                 EXTRN    CODE  (Key_Init)	
				 EXTRN    CODE  (ADC_Init)
				 EXTRN    CODE  (PWM_Init)
				 EXTRN    CODE  (Timer0_Init)
				 EXTRN    CODE  (Extra_IO_Init)
				 EXTRN    CODE  (Frq_Adj_Model)
				 EXTRN    CODE  (Task1_init)
				 EXTRN    CODE  (Task2_init)
				 EXTRN    CODE  (Task3_init)
				 EXTRN    CODE  (Task1)
				 EXTRN    CODE  (Task2)
				 EXTRN    CODE  (Task3)

MainFunc         SEGMENT  CODE
                 RSEG     MainFunc
			
Main:			 ACALL    Power_On_Delay
;Wait power supply become stable.
				 ACALL    Key_Init
                 ACALL    ADC_Init
				 ACALL    Extra_IO_Init
				 ACALL    PWM_Init
				 ACALL    Timer0_Init
;Initialize all necessary peripherals.
                 ACALL    Frq_Adj_Model
;Model selection.
				 ACALL    Task1_init
				 ACALL    Task2_init
				 ACALL    Task3_init
;Task initialization.
Task_cycle:      ACALL    Task1
                 ACALL    Task2
				 ACALL    Task3
                 JMP      Task_cycle
;End of main

Power_On_Delay:  CLR      A
                 MOV      R0,A
                 MOV      R1,A
				 MOV      R2,A
DelayLoop:       DJNZ     R2,DelayLoop
				 DJNZ     R1,DelayLoop
				 DJNZ     R0,DelayLoop
                 RET

                 END

;GPIO function description:
;P1.5: analog input for ADC;
;P1.0, P1.1: PWM output for LED flashing. 
;P3.7: PWM output for boost circuit.
;P3.0: fogger ceramics disc driving signal output.
;P3.2: external key input.  
;P5.4, P5.5: Square wave input&output for liquid level decting.