                 $INCLUDE (Map.inc)                
 
                 NAME     PID
			     PUBLIC   PID_Con_For_PWM
				 EXTRN    CODE  (SMLA_8_16_To_24)
 
Kp               EQU      0x01
Kd               EQU      0x02
SetValueL        EQU      0xA0
SetValueH        EQU      0x02
;PID parameter preset.
PIDVariable      SEGMENT  DATA
                 RSEG     PIDVariable

PID_Err0:        DS       0x02
PID_Err1:        DS       0x02
PID_Err2:        DS       0x02
;Module variable allocation.
				 
PID_Func         SEGMENT  CODE
                 RSEG     PID_Func

PID_Con_For_PWM: MOV      A,#SetValueL
                 CLR      C
				 SUBB     A,R7
				 MOV      PID_Err0,A
				 MOV      R7,A
				 MOV      A,#SetValueH
				 SUBB     A,R6
				 MOV      PID_Err0+1,A
				 MOV      R6,A
				 CLR      A
				 SUBB     A,0xE0
				 MOV      R5,A
;Calculate current error value,[R5,R6,R7], the result is
;also saved to PID_Err0.
                 MOV      A,R5
				 RLC      A
                 MOV      A,R5
				 RRC      A
				 XCH      A,R6
				 RRC      A
				 XCH      A,R7
				 RRC      A
				 XCH      A,R6
				 MOV      R5,A
				 RLC      A
				 MOV      A,R5
				 RRC      A
				 MOV      R1,A
				 MOV      A,R7
				 RRC      A
				 MOV      R2,A
				 MOV      A,R6
				 RRC      A
				 MOV      R3,A
;Ki = 0.25
;[R1,R2,R3]=Ki*[R5,R6,R7]=[R5,R6,R7]/4.
				 MOV      A,PID_Err0
				 CLR      C
				 SUBB     A,PID_Err1
				 MOV      R7,A
				 MOV      R0,A
				 MOV      A,PID_Err0+1
				 SUBB     A,PID_Err1+1
				 MOV      R6,A
				 PUSH     0xE0
;Calculate PID_Err0-PID_Err1, the result is saved to
;[R6,R7].
				 MOV      R5,#Kp
				 ACALL    SMLA_8_16_To_24
;[R5,R6,R7]=Kp*[R6,R7]+[R1,R2,R3].
				 MOV      A,R5
				 MOV      R1,A
				 MOV      A,R6
				 MOV      R2,A
				 MOV      A,R7
				 MOV      R3,A
;[R1,R2,R3]=[R5,R6,R7].
				 MOV      A,PID_Err2
				 CLR      C
				 SUBB     A,PID_Err1
				 XCH      A,PID_Err2+1
				 SUBB     A,PID_Err1+1
				 XCH      A,R0
				 ADD      A,PID_Err2+1
				 MOV      R7,A
				 POP      0xE0
				 ADDC     A,R0
				 MOV      R6,A
;Calculate Err0-Err1+Err2-Err1 and saved the result to
;[R6,R7].
                 MOV      R5,#Kd
				 ACALL    SMLA_8_16_To_24
;[R5,R6,R7]=Kp*[R6,R7]+[R1,R2,R3].
                 MOV      A,CCAP2H
                 ADD      A,R7
				 XCH      A,R6
				 ADDC     A,#0x00
				 XCH      A,R5
				 ADDC     A,#0x00
				 CLR      C
				 RLC      A
				 JC       CCAP2H_Underflow
				 ORL      A,R5
				 JNZ      CCAP2H_Overflow
				 MOV      A,R6
				 ADD      A,#0x19
				 JC       CCAP2H_Overflow
				 MOV      CCAP2H,R6
				 JMP      PID_Func_Return
CCAP2H_Overflow: MOV      CCAP2H,#0xE6
;If CCAP2H plus the increment is more than 214,
;CCAP2H will be limited to 214.
                 JMP      PID_Func_Return
CCAP2H_Underflow:MOV      CCAP2H,#0x00
;If CCAP2H plus the increment is negetive,
;CCAP2H will be limited to 0.
PID_Func_Return: MOV      PID_Err2,PID_Err1
				 MOV      PID_Err2+1,PID_Err1+1
				 MOV      PID_Err1,PID_Err0
				 MOV      PID_Err1+1,PID_Err0+1
;Update last two error value.
				 RET

				 END
