                 $INCLUDE (Map.inc)                

				 NAME     Timer
			     PUBLIC   Timer0_Init
				 PUBLIC   Timer0_handler
				 EXTRN    CODE  (ADC_Start)
				 EXTRN    CODE  (PID_Con_For_PWM)
				 EXTRN    CODE  (LED_PWM_DC_Set)
				 EXTRN    CODE  (PWM_Sim_Gate_Drv)
				 EXTRN    CODE  (Key_Scan)
				 EXTRN    DATA  (Key_Event)

TimerVariable    SEGMENT  DATA
                 RSEG     TimerVariable

Interrupt_Count0:DS       0x01
Interrupt_Count1:DS       0x01
;Module variable allocation.

Timer_Func       SEGMENT  CODE
                 RSEG     Timer_Func

Timer0_Init:	 ORL       AUXR,#0x80
;Timer0 works in 1T model.
                 CLR       A
                 MOV       TMOD,A
;Timer0 is setted to 16-bit auto reload model.
                 MOV       TL0,#0x00
				 MOV       TH0,#0xFD
;Auto relaod value set.
                 SETB      TR0
;Start timer0.
                 ORL       IE,#0x82
;Timer0 and globle interrupt are allowed.
                 RET

Timer0_handler:  PUSH      PSW
                 PUSH      0xE0
				 SETB      PSW.3
;Using register group 1.
                 ACALL     ADC_Start
;Get current output voltage sample.
                 ACALL     PID_Con_For_PWM
;Use PID controler to set pulse width.
                 MOV       A,#0x02
                 ADD       A,Interrupt_Count0
				 MOV       Interrupt_Count0,A
                 JNC       Action_Skip
;when the counter's value overflows, some
;addtional actions will be execute.
                 ACALL     PWM_Sim_Gate_Drv
;PWM simulation for fogger ceramics disc average
;output power control.
                 ACALL     Key_Scan
;Get key input.
				 MOV       Key_Event,R7
;Set key event flag according to the key input.
                 INC       Interrupt_Count1
				 MOV       A,Interrupt_Count1
				 JNZ       Action_Skip
;when the counter's value overflows, some
;addtional actions will be execute.
				 ACALL     LED_PWM_DC_Set
;Change LED light.
Action_Skip:     POP       0xE0
				 POP       PSW
;Recovery registers which were modified before.
                 RETI

                 END